# -*- coding: utf-8 -*-
import libMediathek
import xbmc
import xbmcplugin
import xbmcgui
import urllib2
import json
import re


def main():
	xbmc.log(str(params))
	url = params.get('url','http://akamai-progressive.irt.de/info.xml')
	response = getUrl(url)
	items = re.compile('<item type="(.+?)">(.+?)</item>', re.DOTALL).findall(response)
	for type,item in items:
		name = re.compile('<title>(.+?)</title>', re.DOTALL).findall(item)[0]
		description = re.compile('<description>(.+?)</description>', re.DOTALL).findall(item)[0]
		url = re.compile('<link.+?>(.+?)</link>', re.DOTALL).findall(item)[0]
		if name != 'LOG' and name != 'JPG':
			if type == 'folder':
				libMediathek.addEntry({'name':name,'url':url,'mode':'main','type':'dir'})
			else:
				libMediathek.addEntry({'name':name,'url':url,'mode':'play','type':'video'})#,'thumb':description+'.jpg'})
def play():
	url = params['url']
	listitem = xbmcgui.ListItem(path=url)
	#listitem.setProperty('inputstreamaddon', 'Input Stream')
	if url.endswith('.mpd'):
		listitem.setProperty('inputstreamaddon', 'inputstream.mpd')
	xbmcplugin.setResolvedUrl(pluginhandle, True, listitem)


def getUrl(url):
    xbmc.log(url)
    req = urllib2.Request(url)
    req.add_header('User-Agent', 'Mozilla/5.0 (Windows NT 6.1; rv:25.0) Gecko/20100101 Firefox/25.0')
    response = urllib2.urlopen(req)
    link = response.read()
    response.close()
    return link
	
modes = {
'main': main,
'play': play
}	
def list():	
	global params
	params = libMediathek.get_params()
	global pluginhandle
	pluginhandle = int(sys.argv[1])
	
	if not params.has_key('mode'):
		main()
	else:
		modes.get(params['mode'],main)()
	
	xbmcplugin.endOfDirectory(int(sys.argv[1]))	
	
list()